      subroutine drlse(nobs,y,nind,a,ldx,intcep,b,sst,sse)
!
!     written by J. Goeschel
!
!
      use mod_types
      implicit none
      integer,intent(in):: nobs,nind,intcep,ldx
      integer,parameter:: nrhs=1
      integer:: jpvt(nobs),rank,info
      external dgelsy
      real(8),intent(in):: y(nobs),a(nobs,nind)
      real(8),intent(out)::b(nind+intcep)
      real(8),intent(out)::sst,sse
! note that you might have to increase the size of lwork
! when you increase the sample length (although I chose it
! quite conservatively)
! for details, see doc of dgelsy    
      integer,parameter :: lwork=2000
      real(8) :: work(lwork),rcond
      real(8) :: yfit,my
      integer :: i,j,n
      real(8) :: x(nobs,nind+intcep),xi(nobs,nind+intcep),yi(nobs)
!
! please check if this conditioning is reasonable
      rcond=100*epsilon(1.0_dp)
!
      jpvt(:)=0
      yi=y
!
      if(intcep==0) then
!
      n=nind
      xi=a
      x=a
!
      call dgelsy(nobs,n,nrhs,xi,ldx,yi,nobs,jpvt,rcond,rank,work,lwork,info)
!
      else
!
      n=nind+1
      xi(:,1)=1.0D0
      xi(:,2:n)=a
      x=xi
!
      call dgelsy(nobs,n,nrhs,xi,ldx,yi,nobs,jpvt,rcond,rank,work,lwork,info)
!
      endif
!
! least-squares solution
!
      b(1:n)=yi(1:n)
!
! compute sst
!
      sst=0.0d0
      if(intcep==0) then
 !       do i=1,nobs
 !        sst=sst+y(i)**2
 !       enddo
        ! MATTEO: USE THE SAME FORMULA WITH OR WITHOUT CONSTANT
        my=sum(y)/nobs
        do i=1,nobs
          sst=sst+(y(i)-my)**2
        enddo
      else
        my=sum(y)/nobs
        do i=1,nobs
          sst=sst+(y(i)-my)**2
        enddo
      endif
!
! compute sse
!
      sse=0.0d0
      do i=1,nobs
        yfit=0.0d0
       do j=1,n
        yfit=yfit+x(i,j)*b(j)
       enddo
      sse=sse+(y(i)-yfit)**2
      enddo
!
!     write(*,*) 'info= ',info
!
     end subroutine
