!****************************************************
!routine to compute value function at max_age
!****************************************************
!Marina Pavan
!April 21, 2006
!****************************************************


subroutine last_value

use mod_types
use mod_computation
use mod_utils
use mod_functions

implicit none

real(dp)::v_fo,v_fr  !value of owning a house, value of renting
real(dp), dimension(fulnh)::vtemp  !objective function to maximize, as a function of choices hprime
real(dp)::y0,c0,c1,c11,c2,c,inc,KP !consumption, collateral constraint

real(dp)::vtempp,cp,vtemppr,cpr

real(dp)::hprice  !price of the house given R(shock,K)


real(dp)::Einterest,E1,E2  !expected gross interest rate


integer:: age,ih,ib,ih0,ib0,iy0,iy,iter,ik,iac !,ihh !counters


integer,dimension(1)::index_p  !index of optimal value for h
integer,dimension(fulnh)::index_pp !index of optimal value for b given h
integer::index_ppr   !index of optimal value for b' in renting, given b state




print*, "age=", max_age

!do ihh=1,nhh  !for any value of aggregate housing
	
	do ik=1,nk  !for any value of aggregate K over L
	

	do iy=1,nybz  !income (idiosyncratic + aggregate) & beta


		!artigianale:
		E1=0.0_dp
		E2=0.0_dp
		do iac=1,ns
		E1=E1+pAA(index_Ags(iy),iac)*R(iac,indsKP(1,index_Ags(iy),ik))
		E2=E2+pAA(index_Ags(iy),iac)*R(iac,indsKP(2,index_Ags(iy),ik))
		enddo

		Einterest=valsKP(1,index_Ags(iy),ik)*E1+valsKP(2,index_Ags(iy),ik)*E2

		!house price given shock and K:
		!hprice=R(K)-1+delta_h
		!hprice=R(index_Ags(iy),ik)-idelta
		hprice=1.0_dp-idelta/Einterest
        		         	     
	    !this period earnings:
		inc=ybar(max_age)
		
		do ih0=1,nh(index_beta(iy))    !for any possible value of state h
 
			c0=h(ih0,(index_beta(iy)))*idelta+inc

			index_pp(:)=nb(index_beta(iy))  !set index_b equal to lowest b (search everywhere)
			index_ppr=nnb(index_beta(iy))   !lowest b in renting is 0

			do ib0=nb(index_beta(iy)),1,-1  !for any possible value of state b

			!if degenerate index_ppr, go back to max index
			if (index_ppr==1) then 
				index_ppr=nnb(index_beta(iy)) 
			endif

			
			c11=c0-b(ib0,(index_beta(iy)))*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)

			!**********************************************************
			!1) COMPUTE VALUE OF OWNING A HOUSE: CHOICES ARE H AND B
			!**********************************************************

			do ih=1,nh(index_beta(iy))  ! for any possible choice of h
				
				!if degenerate index_pp, go back to max index
				if (index_pp(ih)==1) then 
					index_pp(ih)=nb(index_beta(iy)) 
				endif
			
			    if (dabs(h(ih,(index_beta(iy)))/h(ih0,(index_beta(iy)))-1.0_dp)>frach) then 
		
				c1=c11-h(ih,(index_beta(iy)))-costh*h(ih0,(index_beta(iy)))  !cash-on-hand minus the expenditure for the house-transaction cost
				
				else
				
				c1=c11-h(ih,(index_beta(iy)))
				
				endif

					!initialize value f. for index b = index_b(ih)  (lowest possible b given choice ih)

						if (b(index_pp(ih),(index_beta(iy)))<=dmin1(coll(ih,(index_beta(iy))),minco*inc)) then

						c=dmax1(c1+b(index_pp(ih),(index_beta(iy))),cmin)
! 						c=(c1+b(index_pp(ih),(index_beta(iy))))

                        else

                        c=cmin
!						c=0.0_dp

						endif
						
						
						Vtemp(ih)=wbeta(index_beta(iy),max_age)*(utility_ret(index_beta(iy),c,h(ih,index_beta(iy)),max_age)+wbequest*dlog(dmax1(cmin,h(ih,index_beta(iy))-b(index_pp(ih),index_beta(iy)))))
!						Vtemp(ih)=utility_ret(c,h(ih,index_beta(iy)),max_age)+wbequest*dlog(dmax1(cmin,-b(index_pp(ih),index_beta(iy))))
						cp=c
						

          				do ib=index_pp(ih)-1,1,-1  !for any possible choice of b>1

						!feasible?

					 	if (b(ib,(index_beta(iy)))<=dmin1(coll(ih,(index_beta(iy))),minco*inc)) then

  						c=dmax1(c1+b(ib,(index_beta(iy))),cmin)
! 						c=(c1+b(ib,(index_beta(iy))))

						else

!						c=0.0_dp
						c=cmin

						endif
                        
						Vtempp=wbeta(index_beta(iy),max_age)*(utility_ret(index_beta(iy),c,h(ih,(index_beta(iy))),max_age)+wbequest*dlog(dmax1(cmin,h(ih,index_beta(iy))-b(ib,index_beta(iy)))))
					
						
						if (Vtempp<Vtemp(ih) .and. cp>cmin) then

						exit

						endif
						
						Vtemp(ih)=Vtempp
						index_pp(ih)=ib
						cp=c


					enddo  !end b choice

					

			enddo  !end h choice

			!******************************
			!value of owning a house:
			!******************************
			v_fo=maxval(Vtemp(1:nh(index_beta(iy))))


			!***************************************************************************
			!2) COMPUTE VALUE OF RENTING A HOUSE: CHOICE IS B, 
			!	H IS INTRA-TEMPORAL DECISION TAKEN INTO ACCOUNT IN BUDGET CONSTRAINT
			!***************************************************************************

			!*****************************************
			!value of renting a house is V_fr
			!*****************************************

			!initialize value of renting at index_ppr (lowest possible choice, exploiting monotonicity):

			c=dmax1((c11-costh*h(ih0,(index_beta(iy)))+b(index_ppr,(index_beta(iy))))/(iiwhouse(max_age)),cmin)
			
			!utility for tenants:
			V_fr=wbeta(index_beta(iy),max_age)*utility_ret_ten(index_beta(iy),c,hprice,max_age)+wbeta(index_beta(iy),max_age)*wbequest*dlog(dmax1(cmin,-b(index_ppr,index_beta(iy))))
			cpr=c

			!choose b:
			do ib=index_ppr-1,1,-1

			c=dmax1((c11-costh*h(ih0,(index_beta(iy)))+b(ib,(index_beta(iy))))/(iiwhouse(max_age)),cmin)

			Vtemppr=wbeta(index_beta(iy),max_age)*utility_ret_ten(index_beta(iy),c,hprice,max_age)+wbeta(index_beta(iy),max_age)*wbequest*dlog(dmax1(cmin,-b(ib,index_beta(iy))))
			
			!exploit concavity:	
			if (Vtemppr<V_fr .and. cpr>cmin) then

			exit

			endif
						
			V_fr=Vtemppr
			index_ppr=ib
			cpr=c

			enddo

			!**************************************
			!IF OWNING LEADS TO HIGHER VALUE:
			!**************************************

			if (v_fo>=v_fr) then

			v_f(max_age,ih0,ib0,iy,ik)=v_fo  !max value
			index_p=maxloc(Vtemp(1:nh(index_beta(iy))))		!index of maximizer
			pol_h(max_age,ih0,ib0,iy,ik)=index_p(1)  !optimal choice of house for state 
			pol_b(max_age,ih0,ib0,iy,ik)=index_pp(index_p(1))  !optimal choice of debt for
			

			!**************************************
			!IF RENTING LEADS TO HIGHER VALUE:
			!**************************************

			else

			v_f(max_age,ih0,ib0,iy,ik)=v_fr  !max value
			pol_h(max_age,ih0,ib0,iy,ik)=1 !house=0
			pol_b(max_age,ih0,ib0,iy,ik)=index_ppr  !optimal choice of debt for
            
			endif
			
		enddo !end b state

		
		enddo !end h state

	enddo  !end y loop
	
	enddo  !end capital loop

!	enddo  !end h aggregate loop

!**************************
!policies saved as indexes:
!FOR MEDIAN AGGR K
!**************************

			open (unit = 91410, file = 'pol_b_11.txt', status='replace')
			open (unit = 91411, file = 'pol_b_12.txt', status='replace')
			open (unit = 91412, file = 'pol_b_21.txt', status='replace')
			open (unit = 91413, file = 'pol_b_22.txt', status='replace')
			open (unit = 91414, file = 'pol_b_m1.txt', status='replace')
			open (unit = 91415, file = 'pol_b_m2.txt', status='replace')
			open (unit = 91510, file = 'pol_h_11.txt', status='replace')
			open (unit = 91511, file = 'pol_h_12.txt', status='replace')
			open (unit = 91512, file = 'pol_h_21.txt', status='replace')
			open (unit = 91513, file = 'pol_h_22.txt', status='replace')
    		open (unit = 91514, file = 'pol_h_m1.txt', status='replace')
			open (unit = 91515, file = 'pol_h_m2.txt', status='replace')
			open (unit = 91610, file = 'pol_l_11.txt', status='replace')
			open (unit = 91611, file = 'pol_l_12.txt', status='replace')
			open (unit = 91612, file = 'pol_l_21.txt', status='replace')
			open (unit = 91613, file = 'pol_l_22.txt', status='replace')
    		open (unit = 91614, file = 'pol_l_m1.txt', status='replace')
			open (unit = 91615, file = 'pol_l_m2.txt', status='replace')


			!IMPATIENT GUY
			do ih0=1,nh(1)
				!WORST AGGREGATE SHOCK, AVERAGE IDIO SHOCK:
			 	write (91410,'(I3)') (pol_b(max_age,ih0,1:nb(1),1,idnint(nk/2.0_dp)))
				write (91510,'(I3)') (pol_h(max_age,ih0,1:nb(1),1,idnint(nk/2.0_dp)))
				!BEST AGGREGATE SHOCK, BEST IDIO SHOCK:
			 	write (91412,'(I3)') (pol_b(max_age,ih0,1:nb(1),ny,idnint(nk/2.0_dp)))
				write (91512,'(I3)') (pol_h(max_age,ih0,1:nb(1),ny,idnint(nk/2.0_dp)))
				!AVERAGE SHOCKS:
			 	write (91414,'(I3)') (pol_b(max_age,ih0,1:nb(1),idnint((ny+1.0_dp)/2.0_dp),idnint(nk/2.0_dp)))
				write (91514,'(I3)') (pol_h(max_age,ih0,1:nb(1),idnint((ny+1.0_dp)/2.0_dp),idnint(nk/2.0_dp)))
			enddo

			!PATIENT GUY

			do ih0=1,nh(2)
				!WORST AGGREGATE SHOCK, AVERAGE IDIO SHOCK:
			 	write (91411,'(I3)') (pol_b(max_age,ih0,1:nb(2),1,idnint(nk/2.0_dp)))
				write (91511,'(I3)') (pol_h(max_age,ih0,1:nb(2),1,idnint(nk/2.0_dp)))
				!BEST AGGREGATE SHOCK, BEST IDIO SHOCK:
			 	write (91413,'(I3)') (pol_b(max_age,ih0,1:nb(2),ny,idnint(nk/2.0_dp)))
				write (91513,'(I3)') (pol_h(max_age,ih0,1:nb(2),ny,idnint(nk/2.0_dp)))
				!AVERAGE SHOCKS:
			 	write (91415,'(I3)') (pol_b(max_age,ih0,1:nb(2),ny+idnint((ny+1.0_dp)/2.0_dp),idnint(nk/2.0_dp)))
				write (91515,'(I3)') (pol_h(max_age,ih0,1:nb(2),ny+idnint((ny+1.0_dp)/2.0_dp),idnint(nk/2.0_dp)))
			enddo

			close (unit = 91410)
			close (unit = 91411)
			close (unit = 91412)
			close (unit = 91413)
			close (unit = 91414)
			close (unit = 91415)
			close (unit = 91510)
			close (unit = 91511)
			close (unit = 91512)
			close (unit = 91513)
			close (unit = 91514)
			close (unit = 91515)
            close (unit = 91610)
			close (unit = 91611)
			close (unit = 91612)
			close (unit = 91613)
			close (unit = 91614)
			close (unit = 91615)
  
  
         

end subroutine last_value
			


















			
		
