!************************************************************
!MAIN ENTRY POINT FOR PROGRAM THAT COMPUTES VALUE AND 
!POLICY FUNCTIONS OF INDEBTEDNESS PROBLEM

!Marina Pavan
!August 4, 2005

!************************************************************


PROGRAM main

USE mod_types
USE mod_computation
USE mod_utils
USE mod_functions

implicit none

integer::age

print*, "DID YOU REMEMBER TO ADJUST DUMMY FOR COMPAQ OPTION???"

!external time

!character(8)::hour

!INCLUDE 'link_f90_static.h'


!open (unit = 2000, file = 'time.txt', status = 'replace')

!call time (hour)

!write (2000,*) (hour)

!close (unit = 2000)

!assign age distribution and survival probabilities
!****************************************************
open(unit=212,file='survival_probability.text',BLANK="NULL",position='rewind')
open(unit=213,file='age_distribution.text',BLANK="NULL",position='rewind')
102 format (F5.1)
103 format (F11.1)
!************************
!READ DATA
!************************
read (unit=212,fmt=102) (p_surv(age),age=1,max_age)
read (unit=213,fmt=103) (p_age(age),age=1,max_age)

!To have constant age distribution
!p_age=1.0_dp/real(max_age,dp) 
!p_surv=1.0_dp
!p_surv(max_age)=0.0_dp

p_age=p_age/sum(p_age(1:max_age))

print*, 'sum p_age=', sum(p_age) 


call markovappr   !to generate Markov transition matrix and y state

call state_generation  !to generate states

call iterations   !iterations on prices

!to output equilibrium statistics, distributions, simulations, etc.:

!call output_stat

!open (unit = 9131, file = 'interest.txt', position = "append")
!write (9131, *) "equilibrium interest:"
!write (9131,  '(f16.4)') (R)
!close (unit=9131)

if (allocated(exxe)) deallocate(exxe)
if (allocated(coefK)) deallocate(coefK)
if (allocated(coefL)) deallocate(coefL)

if (allocated(state)) deallocate(state)
if (allocated(age_state)) deallocate(age_state)

print*, "End of Program"

!open (unit = 2000, file = 'time.txt', position = "append")

!call time(hour)

!write (2000,*) (hour)

!close(unit=2000)


END PROGRAM main


