module mod_nrutil

use mod_types

implicit none

contains

function assert_eq(n1,n2,string)
character(len=*),intent(in)::string
integer,intent(in)::n1,n2
integer::assert_eq
if (n1==n2) then
assert_eq=n1
else
print*, 'nrerror: an assert_eq failed with this tag:',string
STOP 'program terminated by assert_eq'
endif
end function assert_eq

function iminloc(arr)
real(dp),dimension(:),intent(in)::arr
integer, dimension(1)::imin
integer::iminloc
imin=minloc(arr(:))
iminloc=imin(1)
end function iminloc

subroutine nrerror(string)
character(len=*),intent(in)::string
print*, 'nrerror:', string
STOP 'program terminated by nrerror'
end subroutine nrerror

!array funtion returning an arithmetic progression
function arth(first,increment,n)
integer,intent(in)::first,increment,n
integer,dimension(n)::arth
integer::k,k2,temp
integer, parameter::NPAR_ARTH=16,NPAR2_ARTH=8

if (n>0) arth(1)=first
if (n<=NPAR_ARTH) then
	do k=2,n
	arth(k)=arth(k-1)+increment
	enddo
else
	do k=2,NPAR2_ARTH
	arth(k)=arth(k-1)+increment
	enddo
	temp=increment*NPAR2_ARTH
	k=NPAR2_ARTH
	do
		if (k>=n) exit
		k2=k+k
		arth(k+1:min(k2,n))=temp+arth(1:min(k,n-k))
		temp=temp+temp
		k=k2
	enddo
endif
end function arth


subroutine swap(ai,bi)

use mod_types

implicit none

integer, intent(inout)::ai,bi
integer::dum
dum=ai
ai=bi
bi=dum
end subroutine swap


end module mod_nrutil