!*********************************************
!subroutine that simulates choices by
!num_pop agents
!*********************************************


!*************************
!Marina Pavan
!August 2005
!*************************


SUBROUTINE simul1

use mod_types
use mod_utils
use mod_computation
use mod_param
!use NUMERICAL_LIBRARIES

implicit none


!*************************
!VARIABLES
!*************************
real(dp),dimension(num_pop)::b_sim,h_sim,b_sim_state,h_sim_state
real(dp)::l_sim,c_sim,y_sim,adj_sim,d_sim,rh_sim
integer, dimension(num_pop)::bindex,hindex
!real(dp)::dy
real(dp), dimension(time_length)::wag,inte,hprice
real(dp),dimension(time_length)::totAC,totD,totH,totC,totV,totZeta,totZ,totETA,totRH,totS
real(dp), dimension(time_length)::totD_lowbeta, totD_highbeta
real(dp), dimension(time_length)::totC_lowbeta, totC_highbeta
real(dp), dimension(time_length)::totL_lowbeta, totL_highbeta
real(dp), dimension(time_length)::totH_lowbeta, totH_highbeta, totRH_lowbeta,totRH_highbeta, totNFA ! SOE
real(dp), dimension(time_length)::totZeta_lowbeta, totZeta_highbeta


real(dp),dimension(2)::valsK !,valsHH
integer,dimension(2)::indsK !,indsHH
real(dp),dimension(2)::valsb,valsh
integer,dimension(2)::indsb,indsh

real(dp)::expinc  !expected stream of future incomes (discounted)
integer::iac

real(dp)::expint,E11,E12,E22,E21  !expected interest rate

real(dp)::borrower  !borrower indicator

real(dp)::totbeqb,totbeqh   !total bequests (b and h) every period (to be shared by all guys)


!variables for simulated distribution:
!Marina June 2009
!**************************************

!distribution by age, beta and aggregate shock:
real(dp), dimension(max_age,nbeta,ns):: mean_abs_y, mean_abs_b, mean_abs_c, mean_abs_h, mean_abs_l, mean_abs_adj, mean_abs_d, mean_abs_rh, mean_abs_o
!in the loop for people, temporary means:
real(dp), dimension(max_age,nbeta):: temp_mean_y, temp_mean_b, temp_mean_c, &
								& temp_mean_h, temp_mean_l, temp_mean_adj, temp_mean_d, temp_mean_rh, temp_mean_o

!distribution by age and beta:
real(dp), dimension(max_age,nbeta):: mean_ab_y, mean_ab_b, mean_ab_c, mean_ab_h, mean_ab_l, mean_ab_adj, mean_ab_d, mean_ab_rh, mean_ab_o
!distribution by age and aggregate shock:
real(dp), dimension(max_age,ns):: mean_as_y, mean_as_b, mean_as_c, mean_as_h, mean_as_l, mean_as_adj, mean_as_d, mean_as_rh, mean_as_o
!distribution by beta and aggregate shock:
real(dp), dimension(nbeta,ns):: mean_bs_y, mean_bs_b, mean_bs_c, mean_bs_h, mean_bs_l, mean_bs_adj, mean_bs_d, mean_bs_rh, mean_bs_o

!distribution by age:
real(dp), dimension(max_age):: mean_a_y, mean_a_b, mean_a_c, mean_a_h, mean_a_l, mean_a_adj, mean_a_d, mean_a_rh, mean_a_o
!distribution by aggregate shock:
real(dp), dimension(ns):: mean_s_y, mean_s_b, mean_s_c, mean_s_h, mean_s_l, mean_s_adj, mean_s_d, mean_s_rh, mean_s_o
!distribution by beta:
real(dp), dimension(nbeta):: mean_b_y, mean_b_b, mean_b_c, mean_b_h, mean_b_l, mean_b_adj, mean_b_d, mean_b_rh, mean_b_o



!character(8)::hour

!*******
!others:
!*******

integer::j1,tm,m,m1,m2,m3,is,ib,age  !,m4,m5



m=0
totK=0.0_dp
totS=0.0_dp
totV=0.0_dp
totH=0.0_dp
totL=0.0_dp
totAC=0.0_dp
totC=0.0_dp
totD=0.0_dp
totRH=0.0_dp
totZeta=1.0_dp
totD_lowbeta=1.0_dp
totD_highbeta=1.0_dp
totH_lowbeta=1.0_dp
totH_highbeta=1.0_dp
totC_lowbeta=1.0_dp
totC_highbeta=1.0_dp
totL_lowbeta=1.0_dp
totL_highbeta=1.0_dp
totZeta_lowbeta=1.0_dp
totZeta_highbeta=1.0_dp

totK(1)=iniK
totS(1)=iniK
totH(1)=iniH
totL(1)=iniL
totC(1)=iniC



indsK(:)=indsiniK(:)
!indsHH(:)=indsiniHH(:)
valsK(:)=valsiniK(:)
!valsHH(:)=valsiniHH(:)

!indsb(:)=indsinib(:)
!indsh(:)=indsinih(:)
!valsb(:)=valsinib(:)
!valsh(:)=valsinih(:)

b_sim_state(:)=-iniK
h_sim_state(:)=iniH
totbeqb=0.0_dp
totbeqh=0.0_dp

!Marina June 2009
mean_abs_y=0.0_dp
mean_abs_b=0.0_dp
mean_abs_c=0.0_dp
mean_abs_h=0.0_dp
mean_abs_l=0.0_dp
mean_abs_adj=0.0_dp
mean_abs_d=0.0_dp
mean_abs_rh=0.0_dp
mean_abs_o=0.0_dp
mean_ab_y=0.0_dp
mean_ab_b=0.0_dp
mean_ab_c=0.0_dp
mean_ab_h=0.0_dp
mean_ab_l=0.0_dp
mean_ab_adj=0.0_dp
mean_ab_d=0.0_dp
mean_ab_rh=0.0_dp
mean_ab_o=0.0_dp
mean_as_y=0.0_dp
mean_as_b=0.0_dp
mean_as_c=0.0_dp
mean_as_h=0.0_dp
mean_as_l=0.0_dp
mean_as_adj=0.0_dp
mean_as_d=0.0_dp
mean_as_rh=0.0_dp
mean_as_o=0.0_dp
mean_bs_y=0.0_dp
mean_bs_b=0.0_dp
mean_bs_c=0.0_dp
mean_bs_h=0.0_dp
mean_bs_l=0.0_dp
mean_bs_adj=0.0_dp
mean_bs_d=0.0_dp
mean_bs_rh=0.0_dp
mean_bs_o=0.0_dp
mean_a_y=0.0_dp
mean_a_b=0.0_dp
mean_a_c=0.0_dp
mean_a_h=0.0_dp
mean_a_l=0.0_dp
mean_a_adj=0.0_dp
mean_a_d=0.0_dp
mean_a_rh=0.0_dp
mean_a_o=0.0_dp
mean_b_y=0.0_dp
mean_b_b=0.0_dp
mean_b_c=0.0_dp
mean_b_h=0.0_dp
mean_b_l=0.0_dp
mean_b_adj=0.0_dp
mean_b_d=0.0_dp
mean_b_rh=0.0_dp
mean_b_o=0.0_dp
mean_s_y=0.0_dp
mean_s_b=0.0_dp
mean_s_c=0.0_dp
mean_s_h=0.0_dp
mean_s_l=0.0_dp
mean_s_adj=0.0_dp
mean_s_d=0.0_dp
mean_s_rh=0.0_dp
mean_s_o=0.0_dp



open (unit = 9141, file = 'sim_y.txt', status="replace")
open (unit = 9142, file = 'sim_b.txt', status="replace")
open (unit = 9143, file = 'sim_c.txt', status="replace")
open (unit = 9144, file = 'sim_h.txt', status="replace")
open (unit = 9145, file = 'sim_l.txt', status="replace")
open (unit = 9146, file = 'sim_adj.txt', status="replace")
open (unit = 9147, file = 'sim_d.txt', status="replace")
open (unit = 91471, file = 'sim_age.txt', status="replace")
open (unit = 91472, file = 'sim_rh.txt', status='replace')
open (unit = 9148, file = 'sim_y_1.txt', status="replace")
open (unit = 9149, file = 'sim_b_1.txt', status="replace")
open (unit = 9150, file = 'sim_c_1.txt', status="replace")
open (unit = 9151, file = 'sim_h_1.txt', status="replace")
open (unit = 9152, file = 'sim_l_1.txt', status="replace")
open (unit = 9153, file = 'sim_adj_1.txt', status="replace")
open (unit = 9154, file = 'sim_d_1.txt', status="replace")
open (unit = 91541, file = 'sim_age_1.txt', status="replace")
open (unit = 91542, file = 'sim_rh_1.txt', status="replace")
open (unit = 9155, file = 'sim_y_2.txt', status="replace")
open (unit = 9156, file = 'sim_b_2.txt', status="replace")
open (unit = 9157, file = 'sim_c_2.txt', status="replace")
open (unit = 9158, file = 'sim_h_2.txt', status="replace")
open (unit = 9159, file = 'sim_l_2.txt', status="replace")
open (unit = 9160, file = 'sim_adj_2.txt', status="replace")
open (unit = 9161, file = 'sim_d_2.txt', status="replace")
open (unit = 91611, file = 'sim_age_2.txt', status="replace")
open (unit = 91612, file = 'sim_rh_2.txt', status="replace")


do tm=2,time_length

	!Marina June 2009
	temp_mean_y=0.0_dp
	temp_mean_b=0.0_dp
	temp_mean_c=0.0_dp
	temp_mean_h=0.0_dp
	temp_mean_l=0.0_dp
	temp_mean_adj=0.0_dp
	temp_mean_d=0.0_dp
	temp_mean_rh=0.0_dp
	temp_mean_o=0.0_dp
	
	
	!Marina May 2007
	wag(tm)=valsK(1)*Wa(index_Ags(state(1,tm)),indsK(1))+valsK(2)*Wa(index_Ags(state(1,tm)),indsK(2))
    inte(tm)=valsK(1)*R(index_Ags(state(1,tm)),indsK(1))+valsK(2)*R(index_Ags(state(1,tm)),indsK(2))

	!artigianale:
	E11=0.0_dp
	E12=0.0_dp
	E21=0.0_dp
	E22=0.0_dp
	do iac=1,ns
	E11=E11+pAA(index_Ags(state(1,tm)),iac)*R(iac,indsKP(1,index_Ags(state(1,tm)),indsK(1)))
	E21=E21+pAA(index_Ags(state(1,tm)),iac)*R(iac,indsKP(2,index_Ags(state(1,tm)),indsK(1)))
	E12=E12+pAA(index_Ags(state(1,tm)),iac)*R(iac,indsKP(1,index_Ags(state(1,tm)),indsK(2)))
	E22=E22+pAA(index_Ags(state(1,tm)),iac)*R(iac,indsKP(2,index_Ags(state(1,tm)),indsK(2)))
	enddo

	Expint=valsK(1)*(valsKP(1,index_Ags(state(1,tm)),indsK(1))*E11+valsKP(2,index_Ags(state(1,tm)),indsK(1))*E21)+&
		   valsK(2)*(valsKP(1,index_Ags(state(1,tm)),indsK(2))*E12+valsKP(2,index_Ags(state(1,tm)),indsK(2))*E22)
	
	hprice(tm)=1.0_dp-idelta/Expint

	!hprice(tm)=inte(tm)-idelta   
	
	b_sim(:)=0.0_dp
	h_sim(:)=0.0_dp

	!at the beginning of the period, attribute bequests (shared equally among all guys in the pop)
	b_sim_state(:)=b_sim_state(:)+totbeqb/real(num_pop,dp)-totbeqh/real(num_pop,dp)
	h_sim_state(:)=h_sim_state(:)

	!set totbeq again = 0 at the beginning of the period
	totbeqb=0.0_dp
	totbeqh=0.0_dp
	
	do j1=1,num_pop

   

        !update indexes of state
        call basefun(h(:,index_beta(state(j1,tm))),nh(index_beta(state(j1,tm))),h_sim_state(j1),valsh(:),indsh(:))
        call basefun(b(:,index_beta(state(j1,tm))),nb(index_beta(state(j1,tm))),b_sim_state(j1),valsb(:),indsb(:))

       
        !earnings:
        !call polint(k_grid,Wa(index_Ags(state(j1,tm)),:),totK(tm),wag(tm),dy)
        y_sim=wag(tm)*zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))+ybar(age_state(j1,tm))

		if (age_state(j1,tm)<ret_age) then
		expinc=valsK(1)*exp_inc(age_state(j1,tm),(index_Ags(state(j1,tm))-1)*nny+index_Azy(state(j1,tm)),indsK(1))+&
			valsK(2)*exp_inc(age_state(j1,tm),(index_Ags(state(j1,tm))-1)*nny+index_Azy(state(j1,tm)),indsK(2))
		else
		expinc=valsK(1)*exp_pens(age_state(j1,tm)-ret_age+1,index_Ags(state(j1,tm)),indsK(1))+&
			valsK(2)*exp_pens(age_state(j1,tm)-ret_age+1,index_Ags(state(j1,tm)),indsK(2))
		endif


        !choice for capital:
        do m1=1,2
        do m2=1,2
        do m3=1,2
        if (age_state(j1,tm)==1) then
        b_sim(j1)=b_sim(j1)+nint(valsh(m1))*nint(valsb(m2))*nint(valsK(m3))*b(pol_b(age_state(j1,tm),indsh(m1),&
        indsb(m2),state(j1,tm),indsK(m3)),index_beta(state(j1,tm)))
        else
        b_sim(j1)=b_sim(j1)+(valsh(m1))*(valsb(m2))*(valsK(m3))*b(pol_b(age_state(j1,tm),indsh(m1),indsb(m2),&
        state(j1,tm),indsK(m3)),index_beta(state(j1,tm)))
        endif
        enddo
        enddo
        enddo
        
       !choice for house:
        do m1=1,2
        do m2=1,2
        do m3=1,2
        h_sim(j1)=h_sim(j1)+nint(valsh(m1))*nint(valsb(m2))*nint(valsK(m3))*h(pol_h(age_state(j1,tm),indsh(m1),indsb(m2),state(j1,tm),indsK(m3)),index_beta(state(j1,tm)))
        enddo
        enddo
        enddo

        

	
        !consumption:
        !call polint(k_grid,R(index_Ags(state(j1,tm)),:),totK(tm),inte(tm),dy)
        !c_sim(j1,tm)=dmax1(-b_sim(j1,tm-1)*inte(tm)+h_sim(j1,tm-1)*idelta+b_sim(j1,tm)-h_sim(j1,tm),cmin)/itau
        
		! Matteo and Matteo2 May 2007
        
        b_sim(j1)=dmin1(b_sim(j1),mcoll*h_sim(j1),minco*expinc)
        
        if (b_sim(j1)>0.0_dp) then
		borrower=1.0_dp
		else
		borrower=0.0_dp
		endif    
		
		if (age_state(j1,tm)<ret_age) then
			!if homeowner:
			if (h_sim(j1)>0) then 
				c_sim=dmax1(-b_sim_state(j1)*(inte(tm)+borrower*rpremium)+h_sim_state(j1)*idelta+&
                             y_sim*lbar+b_sim(j1)-h_sim(j1)-tax,cmin)/itau(age_state(j1,tm))		
				l_sim=dmax1(0.00001_dp,lbar-tau(age_state(j1,tm))*c_sim/y_sim)
                ! if homeowner not working, recalculate c
                if (l_sim==0.00001_dp) then
                c_sim=dmax1(-b_sim_state(j1)*(inte(tm)+borrower*rpremium)+h_sim_state(j1)*idelta+&
                                       b_sim(j1)-h_sim(j1)-tax,cmin)
                endif
                ! if homeowner adjusts, recalculate c and l
                if (dabs(h_sim(j1)/h_sim_state(j1)-1.0_dp)>frach) then
				c_sim=dmax1(cmin,c_sim-costh*h_sim_state(j1)/itau(age_state(j1,tm)))
				l_sim=dmax1(0.00001_dp,lbar-tau(age_state(j1,tm))*c_sim/y_sim)
				endif            
    			rh_sim=0.0_dp
			 !if renter:
             else
				c_sim=dmax1((-b_sim_state(j1)*(inte(tm)+borrower*rpremium)+h_sim_state(j1)*(idelta-costh)+&
                             y_sim*lbar+b_sim(j1)-tax)/(itau(age_state(j1,tm))+whouse(age_state(j1,tm))),cmin)
				l_sim=dmax1(0.00001_dp,lbar-tau(age_state(j1,tm))*c_sim/y_sim)
                ! if renter not working, recalculate c
                if (l_sim==0.00001_dp) then
                c_sim=dmax1((-b_sim_state(j1)*(inte(tm)+borrower*rpremium)+h_sim_state(j1)*(idelta-costh)+&
                                       b_sim(j1)-tax)/(1.0_dp+whouse(age_state(j1,tm))),cmin)
                endif          
				rh_sim=whouse(age_state(j1,tm))*c_sim/hprice(tm)
			endif
		else
			!if homeowner:
			if (h_sim(j1)>0) then 
				c_sim=dmax1(-b_sim_state(j1)*(inte(tm)+borrower*rpremium)+h_sim_state(j1)*idelta+y_sim+b_sim(j1)-h_sim(j1),cmin)	
				if (dabs(h_sim(j1)/h_sim_state(j1)-1.0_dp)>frach) then
				c_sim=dmax1(cmin,c_sim-costh*h_sim_state(j1))
				endif
				rh_sim=0.0_dp
			!if renter
			else
				c_sim=dmax1((-b_sim_state(j1)*(inte(tm)+borrower*rpremium)+h_sim_state(j1)*(idelta-costh)+&
                             y_sim+b_sim(j1))/iiwhouse(age_state(j1,tm)),cmin)
				rh_sim=whouse(age_state(j1,tm))*c_sim/hprice(tm)
			endif
			l_sim=0.0_dp
		endif
        
        
        !debt:
        d_sim=dmax1(b_sim_state(j1),0.0_dp)


        if (h_sim_state(j1)>0) then
			!adjustment cost of housing investment:
			if (dabs(h_sim(j1)/h_sim_state(j1)-1.0_dp)>frach) then 
			adj_sim=costh*h_sim_state(j1)  !house-transaction cost
            totV(tm)=totV(tm)+1.0_dp
			else
			adj_sim=0.0_dp
			endif
		else
			adj_sim=0.0_dp
		endif
		
        
		totL(tm)=totL(tm)+zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))*l_sim
		totL_lowbeta(tm)=totL_lowbeta(tm)+zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))*l_sim*real(indbetalow(j1,tm),dp)
		totL_highbeta(tm)=totL_highbeta(tm)+zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))*l_sim*real(indbetahigh(j1,tm),dp)
		totC(tm)=totC(tm)+c_sim
		totC_lowbeta(tm)=totC_lowbeta(tm)+c_sim*real(indbetalow(j1,tm),dp)
		totC_highbeta(tm)=totC_highbeta(tm)+c_sim*real(indbetahigh(j1,tm),dp)
		totAC(tm)=totAC(tm)+adj_sim
        totD(tm)=totD(tm)+d_sim
		totD_lowbeta(tm)=totD_lowbeta(tm)+d_sim*real(indbetalow(j1,tm),dp)
		totD_highbeta(tm)=totD_highbeta(tm)+d_sim*real(indbetahigh(j1,tm),dp)
		totH_lowbeta(tm)=totH_lowbeta(tm)+h_sim(j1)*real(indbetalow(j1,tm),dp)
		totH_highbeta(tm)=totH_highbeta(tm)+h_sim(j1)*real(indbetahigh(j1,tm),dp)

		totRH(tm)=totRH(tm)+rh_sim
		totRH_lowbeta(tm)=totRH_lowbeta(tm)+rh_sim*real(indbetalow(j1,tm),dp)
		totRH_highbeta(tm)=totRH_highbeta(tm)+rh_sim*real(indbetahigh(j1,tm),dp)

		totZeta(tm)=totZeta(tm)+zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))
		totZeta_lowbeta(tm)=totZeta_lowbeta(tm)+zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))*real(indbetalow(j1,tm),dp)
		totZeta_highbeta(tm)=totZeta_highbeta(tm)+zy(index_Azy(state(j1,tm)))*eta(age_state(j1,tm))*real(indbetahigh(j1,tm),dp)
		totZ(tm)=totZ(tm)+zy(index_Azy(state(j1,tm)))
        totETA(tm)=totETA(tm)+eta(age_state(j1,tm))

		!Marina June 2009
		!compute means for distribution over age and aggregate shocks:
		
		if (tm>=TAC) then
		temp_mean_y(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_y(age_state(j1,tm),index_beta(state(j1,tm)))+y_sim
		temp_mean_b(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_b(age_state(j1,tm),index_beta(state(j1,tm)))+b_sim(j1)
		temp_mean_c(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_c(age_state(j1,tm),index_beta(state(j1,tm)))+c_sim
		temp_mean_h(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_h(age_state(j1,tm),index_beta(state(j1,tm)))+h_sim(j1)
		temp_mean_l(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_l(age_state(j1,tm),index_beta(state(j1,tm)))+l_sim
		temp_mean_adj(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_adj(age_state(j1,tm),index_beta(state(j1,tm)))+adj_sim
		temp_mean_d(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_d(age_state(j1,tm),index_beta(state(j1,tm)))+d_sim
		temp_mean_rh(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_rh(age_state(j1,tm),index_beta(state(j1,tm)))+rh_sim
        if (rh_sim==0.0_dp) then
		temp_mean_o(age_state(j1,tm),index_beta(state(j1,tm)))=temp_mean_o(age_state(j1,tm),index_beta(state(j1,tm)))+1.0_dp
		endif
        endif

		!if the guy survives until the next period:
		if (tm<time_length .and. age_state(j1,tm+1)>age_state(j1,tm)) then

		!*********************************************************************************
		!NOTE: in the above it must be that wbequest=0 for things to make sense
		!If you set wbequest>0 and you want that the guy at the last age can give a bequest 
		!to his son specifically you could use the following line:
		!
		!if (tm<time_length .and. age_state(j1,tm+1)>age_state(j1,tm) .or. age_state(j1,tm)==max_age) then
		!*****************************************************************************************************

		b_sim_state(j1)=b_sim(j1)
		h_sim_state(j1)=h_sim(j1)
        
		else

		b_sim_state(j1)=(1.0_dp-sharedbequest_dummy)*b_sim(j1)
		h_sim_state(j1)=(1.0_dp-sharedbequest_dummy)*h_sim(j1)

		!bequests of the dead guy:
		totbeqb=totbeqb+sharedbequest_dummy*(b_sim(j1)-h_sim(j1))
		totbeqh=totbeqh

		endif


        !median impatient guy
	    if (j1==guy1) then
	    
	    write (9148,'(f16.4)') (y_sim)
        write (9149,'(f16.4)') (b_sim(guy1))
        write (9150,'(f16.4)') (c_sim)
        write (9151,'(f16.4)') (h_sim(guy1))
        write (9152,'(f16.4)') (l_sim)
        write (9153,'(f16.4)') (adj_sim)
        write (9154,'(f16.4)') (d_sim)
	    write (91541,'(I2)') (age_state(guy1,tm))
		write (91542,'(f16.4)') (rh_sim)

	    endif
	    
	    !median patient guy
	    if (j1==guy2) then
	    
	    write (9155,'(f16.4)') (y_sim)
        write (9156,'(f16.4)') (b_sim(guy2))
        write (9157,'(f16.4)') (c_sim)
        write (9158,'(f16.4)') (h_sim(guy2))
        write (9159,'(f16.4)') (l_sim)
        write (9160,'(f16.4)') (adj_sim)
        write (9161,'(f16.4)') (d_sim)
        write (91611,'(I2)') (age_state(guy2,tm))
		write (91612,'(f16.4)') (rh_sim)

	    endif

		! INDIVIDUAL VARIABLES: SAVE FROM Time_start onwards

!    if (tm>time_start .and. j1<=num_pop1) then   
!    if (tm>time_start .and. j1>=guy2-num_pop1/2 .and. j1<guy2+num_pop1/2) then   
!    if (tm>time_start .and. j1>=num_pop-num_pop1+1) then   
     if (tm>time_start .and. (j1>=(idnint((num_pop-num_pop1)*pbetastat(1)))) .and. (j1<(idnint((num_pop-num_pop1)*pbetastat(1))+num_pop1))) then   

       
        write (9141,  '(f16.4)') (y_sim)
        
        write (9142,  '(f16.4)') (b_sim(j1))
        
        write (9143,  '(f16.4)') (c_sim)
        
        write (9144,  '(f16.4)') (h_sim(j1))
       
        write (9145,  '(f16.4)') (l_sim)

        write (9146,  '(f16.4)') (adj_sim)
        
        write (9147,  '(f16.4)') (d_sim)

		write (91471,  '(I2)') (age_state(j1,tm))

		write (91472,  '(f16.4)') (rh_sim)
        
		endif
        
    enddo
		
		if (tm>=TAC) then
		!Marina June 2009
		!compute mean by age at tm:
		do age=1,max_age
		do ib=1,nbeta
		temp_mean_y(age,ib)=temp_mean_y(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_b(age,ib)=temp_mean_b(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_c(age,ib)=temp_mean_c(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_h(age,ib)=temp_mean_h(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_l(age,ib)=temp_mean_l(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_adj(age,ib)=temp_mean_adj(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_d(age,ib)=temp_mean_d(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_rh(age,ib)=temp_mean_rh(age,ib)/real(count_ab_people(age,ib,tm),dp)
		temp_mean_o(age,ib)=temp_mean_o(age,ib)/real(count_ab_people(age,ib,tm),dp)
		enddo
		enddo
		
	
	
		!Marina June 2009
		!mean over time (by age, beta and aggregate shocks)
		do ib=1,nbeta
		mean_abs_y(:,ib,index_Ags(state(1,tm)))=mean_abs_y(:,ib,index_Ags(state(1,tm)))+temp_mean_y(:,ib)
		mean_abs_b(:,ib,index_Ags(state(1,tm)))=mean_abs_b(:,ib,index_Ags(state(1,tm)))+temp_mean_b(:,ib)
		mean_abs_c(:,ib,index_Ags(state(1,tm)))=mean_abs_c(:,ib,index_Ags(state(1,tm)))+temp_mean_c(:,ib)
		mean_abs_h(:,ib,index_Ags(state(1,tm)))=mean_abs_h(:,ib,index_Ags(state(1,tm)))+temp_mean_h(:,ib)
		mean_abs_l(:,ib,index_Ags(state(1,tm)))=mean_abs_l(:,ib,index_Ags(state(1,tm)))+temp_mean_l(:,ib)
		mean_abs_adj(:,ib,index_Ags(state(1,tm)))=mean_abs_adj(:,ib,index_Ags(state(1,tm)))+temp_mean_adj(:,ib)
		mean_abs_d(:,ib,index_Ags(state(1,tm)))=mean_abs_d(:,ib,index_Ags(state(1,tm)))+temp_mean_d(:,ib)
		mean_abs_rh(:,ib,index_Ags(state(1,tm)))=mean_abs_rh(:,ib,index_Ags(state(1,tm)))+temp_mean_rh(:,ib)
		mean_abs_o(:,ib,index_Ags(state(1,tm)))=mean_abs_o(:,ib,index_Ags(state(1,tm)))+temp_mean_o(:,ib)
		enddo

		!mean by beta and aggregate shock:
		do age=1,max_age
		mean_bs_y(:,index_Ags(state(1,tm)))=mean_bs_y(:,index_Ags(state(1,tm)))+temp_mean_y(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_b(:,index_Ags(state(1,tm)))=mean_bs_b(:,index_Ags(state(1,tm)))+temp_mean_b(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_c(:,index_Ags(state(1,tm)))=mean_bs_c(:,index_Ags(state(1,tm)))+temp_mean_c(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_h(:,index_Ags(state(1,tm)))=mean_bs_h(:,index_Ags(state(1,tm)))+temp_mean_h(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_l(:,index_Ags(state(1,tm)))=mean_bs_l(:,index_Ags(state(1,tm)))+temp_mean_l(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_adj(:,index_Ags(state(1,tm)))=mean_bs_adj(:,index_Ags(state(1,tm)))+temp_mean_adj(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_d(:,index_Ags(state(1,tm)))=mean_bs_d(:,index_Ags(state(1,tm)))+temp_mean_d(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_rh(:,index_Ags(state(1,tm)))=mean_bs_rh(:,index_Ags(state(1,tm)))+temp_mean_rh(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		mean_bs_o(:,index_Ags(state(1,tm)))=mean_bs_o(:,index_Ags(state(1,tm)))+temp_mean_o(age,:)*real(count_a_people(age,tm),dp)/real(num_pop,dp)
		enddo

		endif  !end tm>=tac


		!tot rented housing capital:
		totRH(tm)=totRH(tm)/real(num_pop,dp)

		totH(tm)=totRH(tm)+sum(h_sim(:))/real(num_pop,dp) 
        totL(tm)=totL(tm)/real(num_pop,dp)
        totL_lowbeta(tm)=totL_lowbeta(tm)/(pbetastat(1)*real(num_pop,dp))
		totL_highbeta(tm)=totL_highbeta(tm)/(1.0_dp-pbetastat(1))/real(num_pop,dp)
        totC(tm)=totC(tm)/real(num_pop,dp)
        totC_lowbeta(tm)=totC_lowbeta(tm)/(pbetastat(1)*real(num_pop,dp))
		totC_highbeta(tm)=totC_highbeta(tm)/(1.0_dp-pbetastat(1))/real(num_pop,dp)        
        totV(tm)=totV(tm)/real(num_pop,dp)
        totAC(tm)=totAC(tm)/real(num_pop,dp)
        totD(tm)=totD(tm)/real(num_pop,dp)
		totD_lowbeta(tm)=totD_lowbeta(tm)/(pbetastat(1)*real(num_pop,dp))
		totD_highbeta(tm)=totD_highbeta(tm)/(1.0_dp-pbetastat(1))/real(num_pop,dp)
		totH_lowbeta(tm)=totH_lowbeta(tm)/(pbetastat(1)*real(num_pop,dp))
		totH_highbeta(tm)=totH_highbeta(tm)/(1.0_dp-pbetastat(1))/real(num_pop,dp)
		totZeta(tm)=totZeta(tm)/real(num_pop,dp)
		totZ(tm)=totZ(tm)/real(num_pop,dp)
		totETA(tm)=totETA(tm)/real(num_pop,dp)
        totZeta_lowbeta(tm)=totZeta_lowbeta(tm)/(pbetastat(1)*real(num_pop,dp))
		totZeta_highbeta(tm)=totZeta_highbeta(tm)/(1.0_dp-pbetastat(1))/real(num_pop,dp)

        if (soe_dummy==0) then
            ! CLOSED ECONOMY
            totS(tm)=sum(-b_sim(:))/real(num_pop,dp)
            totK(tm)=totS(tm)+(hprice(tm)-1.0_dp)*totRH(tm)
            totNFA(tm)=0
        else
            ! SMALL OPEN ECONOMY
            totS(tm)=sum(-b_sim(:))/real(num_pop,dp) 
            totK(tm)=totL(tm)*(alfa/(interest_soe-ideltak))**iialfa
            totNFA(tm)=totS(tm)+(hprice(tm)-1.0_dp)*totRH(tm)-totK(tm)
        endif

        
        call basefun(K_grid,nk,totK(tm),valsK(:),indsK(:))
        
       
        !exxe is matrix for regression
        if (tm>TAC) then
        m=m+1
        dipK(m)=totK(tm)
        dipL(m)=totL(tm)
        do is=1,ns
        exxe(m,ns+is)=exxe(m,is)*dipK(m)
        enddo
        endif


enddo  !end time

!Marina June 2009

do is=1,ns

do age=1,max_age
do ib=1,nbeta

!compute means by age and beta:
mean_ab_y(age,ib)=mean_ab_y(age,ib)+mean_abs_y(age,ib,is)/real(time_length-TAC,dp)
mean_ab_b(age,ib)=mean_ab_b(age,ib)+mean_abs_b(age,ib,is)/real(time_length-TAC,dp)
mean_ab_c(age,ib)=mean_ab_c(age,ib)+mean_abs_c(age,ib,is)/real(time_length-TAC,dp)
mean_ab_h(age,ib)=mean_ab_h(age,ib)+mean_abs_h(age,ib,is)/real(time_length-TAC,dp)
mean_ab_l(age,ib)=mean_ab_l(age,ib)+mean_abs_l(age,ib,is)/real(time_length-TAC,dp)
mean_ab_adj(age,ib)=mean_ab_adj(age,ib)+mean_abs_adj(age,ib,is)/real(time_length-TAC,dp)
mean_ab_d(age,ib)=mean_ab_d(age,ib)+mean_abs_d(age,ib,is)/real(time_length-TAC,dp)
mean_ab_rh(age,ib)=mean_ab_rh(age,ib)+mean_abs_rh(age,ib,is)/real(time_length-TAC,dp)
mean_ab_o(age,ib)=mean_ab_o(age,ib)+mean_abs_o(age,ib,is)/real(time_length-TAC,dp)

!compute means by age, beta and aggregate shock:
mean_abs_y(age,ib,is)=mean_abs_y(age,ib,is)/real(count_s(is),dp)
mean_abs_b(age,ib,is)=mean_abs_b(age,ib,is)/real(count_s(is),dp)
mean_abs_c(age,ib,is)=mean_abs_c(age,ib,is)/real(count_s(is),dp)
mean_abs_h(age,ib,is)=mean_abs_h(age,ib,is)/real(count_s(is),dp)
mean_abs_l(age,ib,is)=mean_abs_l(age,ib,is)/real(count_s(is),dp)
mean_abs_adj(age,ib,is)=mean_abs_adj(age,ib,is)/real(count_s(is),dp)
mean_abs_d(age,ib,is)=mean_abs_d(age,ib,is)/real(count_s(is),dp)
mean_abs_rh(age,ib,is)=mean_abs_rh(age,ib,is)/real(count_s(is),dp)
mean_abs_o(age,ib,is)=mean_abs_o(age,ib,is)/real(count_s(is),dp)

enddo
enddo

!compute means by beta:
mean_b_y(:)=mean_b_y(:)+mean_bs_y(:,is)/real(time_length-TAC,dp)
mean_b_b(:)=mean_b_b(:)+mean_bs_b(:,is)/real(time_length-TAC,dp)
mean_b_c(:)=mean_b_c(:)+mean_bs_c(:,is)/real(time_length-TAC,dp)
mean_b_h(:)=mean_b_h(:)+mean_bs_h(:,is)/real(time_length-TAC,dp)
mean_b_l(:)=mean_b_l(:)+mean_bs_l(:,is)/real(time_length-TAC,dp)
mean_b_adj(:)=mean_b_adj(:)+mean_bs_adj(:,is)/real(time_length-TAC,dp)
mean_b_d(:)=mean_b_d(:)+mean_bs_d(:,is)/real(time_length-TAC,dp)
mean_b_rh(:)=mean_b_rh(:)+mean_bs_rh(:,is)/real(time_length-TAC,dp)
mean_b_o(:)=mean_b_o(:)+mean_bs_o(:,is)/real(time_length-TAC,dp)


!compute means by beta and aggregate shock:
mean_bs_y(:,is)=mean_bs_y(:,is)/real(count_s(is),dp)
mean_bs_b(:,is)=mean_bs_b(:,is)/real(count_s(is),dp)
mean_bs_c(:,is)=mean_bs_c(:,is)/real(count_s(is),dp)
mean_bs_h(:,is)=mean_bs_h(:,is)/real(count_s(is),dp)
mean_bs_l(:,is)=mean_bs_l(:,is)/real(count_s(is),dp)
mean_bs_adj(:,is)=mean_bs_adj(:,is)/real(count_s(is),dp)
mean_bs_d(:,is)=mean_bs_d(:,is)/real(count_s(is),dp)
mean_bs_rh(:,is)=mean_bs_rh(:,is)/real(count_s(is),dp)
mean_bs_o(:,is)=mean_bs_o(:,is)/real(count_s(is),dp)



!compute means by age and aggregate shock:
do ib=1,nbeta
mean_as_y(:,is)=mean_as_y(:,is)+mean_abs_y(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_b(:,is)=mean_as_b(:,is)+mean_abs_b(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_c(:,is)=mean_as_c(:,is)+mean_abs_c(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_h(:,is)=mean_as_h(:,is)+mean_abs_h(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_l(:,is)=mean_as_l(:,is)+mean_abs_l(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_adj(:,is)=mean_as_adj(:,is)+mean_abs_adj(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_d(:,is)=mean_as_d(:,is)+mean_abs_d(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_rh(:,is)=mean_as_rh(:,is)+mean_abs_rh(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_as_o(:,is)=mean_as_o(:,is)+mean_abs_o(:,ib,is)*real(count_b_people(ib),dp)/real(num_pop,dp)
enddo


enddo


do ib=1,nbeta

!compute means by age:
mean_a_y(:)=mean_a_y(:)+mean_ab_y(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_b(:)=mean_a_b(:)+mean_ab_b(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_c(:)=mean_a_c(:)+mean_ab_c(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_h(:)=mean_a_h(:)+mean_ab_h(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_l(:)=mean_a_l(:)+mean_ab_l(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_adj(:)=mean_a_adj(:)+mean_ab_adj(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_d(:)=mean_a_d(:)+mean_ab_d(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_rh(:)=mean_a_rh(:)+mean_ab_rh(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_a_o(:)=mean_a_o(:)+mean_ab_o(:,ib)*real(count_b_people(ib),dp)/real(num_pop,dp)

!compute means by aggregate shock:
mean_s_y(:)=mean_s_y(:)+mean_bs_y(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_b(:)=mean_s_b(:)+mean_bs_b(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_c(:)=mean_s_c(:)+mean_bs_c(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_h(:)=mean_s_h(:)+mean_bs_h(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_l(:)=mean_s_l(:)+mean_bs_l(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_adj(:)=mean_s_adj(:)+mean_bs_adj(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_d(:)=mean_s_d(:)+mean_bs_d(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_rh(:)=mean_s_rh(:)+mean_bs_rh(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)
mean_s_o(:)=mean_s_o(:)+mean_bs_o(ib,:)*real(count_b_people(ib),dp)/real(num_pop,dp)

enddo



!open (unit = 2000, file = 'time.txt', position='append')
!call time (hour)
!write (2000,*) "End time and pop simulations:"
!write (2000,*) (hour)
!close (unit = 2000)
        


        close (unit=9141)
        close (unit=9142)
        close (unit=9143)
        close (unit=9144)
        close (unit=9145)
        close (unit=9146)
        close (unit=9147)
		close (unit=91471)
		close (unit=91472)
        close (unit=9148)
        close (unit=9149)
        close (unit=9150)
        close (unit=9151)
        close (unit=9152)
        close (unit=9153)
        close (unit=9154)
		close (unit=91541)
		close (unit=91542)
        close (unit=9155)
        close (unit=9156)
        close (unit=9157)
        close (unit=9158)
        close (unit=9159)
        close (unit=9160)
        close (unit=9161)
		close (unit=91611)
		close (unit=91612)

    !   open (unit = 9141, file = 'sim_y1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (y_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
       !	open (unit = 9141, file = 'sim_y2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (y_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
	
       !	open (unit = 9141, file = 'sim_b1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (b_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
        !	open (unit = 9141, file = 'sim_b2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (b_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
		
	!	open (unit = 9141, file = 'sim_c1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (c_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
	!	open (unit = 9141, file = 'sim_c2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (c_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
		
	!	open (unit = 9141, file = 'sim_l1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (l_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
	!       open (unit = 9141, file = 'sim_l2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (l_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
		
	!	open (unit = 9141, file = 'sim_adj1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (adj_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
        !	open (unit = 9141, file = 'sim_adj2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (adj_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
		
	!	open (unit = 9141, file = 'sim_d1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (d_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
	!       open (unit = 9141, file = 'sim_d2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (d_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
		
	!	open (unit = 9141, file = 'sim_h1.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (h_sim(guy1,tm))
	!	enddo
	!	close (unit=9141)
	
	!	open (unit = 9141, file = 'sim_h2.txt', status="replace")
	!	do tm=1,time_length
	!	write (9141,  '(f16.4)') (h_sim(guy2,tm))
	!	enddo
	!	close (unit=9141)
		
		! AGGREGATE VARIABLES: SAVE ALL PERIODS

		open (unit = 9141, file = 'totKoverL.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totK(tm)/totL(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totK.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totK(tm))
		enddo
		close (unit=9141)

        open (unit = 9141, file = 'totS.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totS(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totH.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totH(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totRH.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totRH(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totL.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totL(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totC.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totC(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totV.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totV(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totAC.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totAC(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totD.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totD(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totZeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totZeta(tm))
		enddo
		close (unit=9141)

   		open (unit = 9141, file = 'totZ.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totZ(tm))
		enddo
		close (unit=9141)

   		open (unit = 9141, file = 'totETA.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totETA(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totD_lowbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totD_lowbeta(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totD_highbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totD_highbeta(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totH_lowbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totH_lowbeta(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totH_highbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totH_highbeta(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totC_lowbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totC_lowbeta(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totC_highbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totC_highbeta(tm))
		enddo
		close (unit=9141)
		
		open (unit = 9141, file = 'totL_lowbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totL_lowbeta(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totL_highbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totL_highbeta(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totZeta_lowbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totZeta_lowbeta(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'totZeta_highbeta.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totZeta_highbeta(tm))
		enddo
		close (unit=9141)


		open (unit = 9141, file = 'interest.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (inte(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'wage.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (wag(tm))
		enddo
		close (unit=9141)

		open (unit = 9141, file = 'hprice.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (hprice(tm))
		enddo
		close (unit=9141)
        
        open (unit = 9141, file = 'totNFA.txt', status="replace")
		do tm=1,time_length
		write (9141,  '(f16.4)') (totNFA(tm))
		enddo
		close (unit=9141)

		!Marina June 2009
		!DISTRIBUTION OF VARIABLES BY AGE, BETA AND AGGREGATE SHOCK:

        open (unit = 9141, file = 'mean_abs_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_abs_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_abs_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_abs_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_abs_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_abs_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_abs_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_abs_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_abs_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_abs_o)
		close (unit=9141)

		!DISTRIBUTION OF VARIABLES BY AGE AND AGGREGATE SHOCK:

        open (unit = 9141, file = 'mean_as_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_as_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_as_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_as_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_as_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_as_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_as_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_as_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_as_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_as_o)
		close (unit=9141)


		!DISTRIBUTION OF VARIABLES BY AGE and BETA:

        open (unit = 9141, file = 'mean_ab_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_ab_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_ab_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_ab_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_ab_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_ab_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_ab_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_ab_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_ab_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_ab_o)
		close (unit=9141)


		!DISTRIBUTION OF VARIABLES BY BETA AND AGGREGATE SHOCK:

        open (unit = 9141, file = 'mean_bs_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_bs_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_bs_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_bs_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_bs_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_bs_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_bs_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_bs_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_bs_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_bs_o)
		close (unit=9141)

		!DISTRIBUTION OF VARIABLES BY AGE:

        open (unit = 9141, file = 'mean_a_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_a_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_a_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_a_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_a_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_a_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_a_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_a_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_a_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_a_o)
		close (unit=9141)

		!DISTRIBUTION OF VARIABLES BY AGGREGATE SHOCK:

        open (unit = 9141, file = 'mean_s_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_s_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_s_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_s_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_s_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_s_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_s_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_s_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_s_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_s_o)
		close (unit=9141)


    	!DISTRIBUTION OF VARIABLES BY BETA:

        open (unit = 9141, file = 'mean_b_y.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_y)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_b_b.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_b)
		close (unit=9141)

		open (unit = 9141, file = 'mean_b_c.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_c)
		close (unit=9141)

		open (unit = 9141, file = 'mean_b_h.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_h)
		close (unit=9141)

		open (unit = 9141, file = 'mean_b_l.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_l)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_b_adj.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_adj)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_b_d.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_d)
		close (unit=9141)
		
		open (unit = 9141, file = 'mean_b_rh.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_rh)
		close (unit=9141)

		open (unit = 9141, file = 'mean_b_o.txt', status="replace")
		write (9141,  '(f16.4)') (mean_b_o)
		close (unit=9141)


END SUBROUTINE simul1
